//+------------------------------------------------------------------+
//|                                                   ma crosses.mq4 |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  Green
#property indicator_color2  Red
#property indicator_color3  Aqua
#property indicator_color4  Magenta

//
//
//
//
//

extern bool   alertsOn           = true;
extern bool   alertsOnCurrent    = true;
extern bool   alertsMessage      = true;
extern bool   alertsSound        = true;
extern bool   alertsEmail        = false;

//
//
//
//
//

double CrossUp[];
double CrossDn[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{
   IndicatorBuffers(6);   
   SetIndexBuffer(0, CrossUp);  SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,217);
   SetIndexBuffer(1, CrossDn ); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,217);
   SetIndexBuffer(2, trend);
   
         
   IndicatorShortName(" M ");
return(0);
}

//
//
//
//
//

int deinit() {  return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int start() 
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
       
   //
   //
   //
   //
   //
   
     for(i=limit; i>=0; i--)
     {
        double ema13   = iMA(NULL,0,13,0,MODE_EMA,PRICE_CLOSE,i);
        double ema5    = iMA(NULL,0,5,0,MODE_EMA,PRICE_CLOSE,i);
        double b4ema13 = iMA(NULL,0,13,0,MODE_EMA,PRICE_CLOSE,i+1);
        double b4ema5  = iMA(NULL,0,5,0,MODE_EMA,PRICE_CLOSE,i+1);
        double mom     = iMomentum(NULL,0,14,PRICE_CLOSE,i);
        double b4mom   = iMomentum(NULL,0,14,PRICE_CLOSE,i+1);
        trend[i]  = trend[i+1];
           if ((ema5>ema13)&&(ema5>b4ema5)&&(ema13>b4ema13)&&(mom>b4mom)&&(mom>98.6591))  trend[i] = 1;
           if ((ema5<ema13)&&(ema5<b4ema5)&&(ema13<b4ema13)&&(mom<b4mom)&&(mom<100.6872)) trend[i] =-1;

           //
           //
           //
           //
           //
      
          CrossUp[i] = EMPTY_VALUE;
          CrossDn[i] = EMPTY_VALUE;
          if (trend[i]!= trend[i+1])
          if (trend[i] == 1)
                CrossUp[i] = Low[i]  - iATR(NULL,0,20,i)/2;
          else  CrossDn[i] = High[i] + iATR(NULL,0,20,i)/2;
      }   
manageAlerts();
return(0);
}
      
      

//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; 
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"buy");
         if (trend[whichBar] ==-1) doAlert(whichBar,"sell");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

        message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," M ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," M "),message);
             if (alertsSound)   PlaySound("alert2.wav");
   }
}